% calcAsymImages.m 
% Written: Mark Eckert, 2/25/2019

% This code snippet creates asymmetry images using log Jacobian images.
% log Jacobians can be subtracted to produce the equivalent asymmetries 
% to (i1-i2)/.((i1+i2)/2) when using non-log data

% Please note that we have indicated below where you should provide your 
% project-specific information with % EDIT HERE.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Directory to write the images                
cd '/yourPath/images/Step03_Xforms/jacobians/';                                % EDIT HERE.  Step 3 or fine resolution example 
 
subjects = '/yourPath/IDs.txt';                                                % EDIT HERE.
subject_nums = textread(subjects, '%s', 'delimiter', '\n');
nsubs = length(subject_nums);

% Perform the subtraction using SPM's imCalc
addpath /yourSPMpath;                                                          % EDIT HERE. 
for s = 1:nsubs;
   imName = sprintf('/yourPath/swAJ_%s.nii,1', subject_nums{s});               % EDIT HERE.
   imCalcInput = strvcat(imName);
   imCalcOutputName = fullfile(['asym_' subject_nums{s} '.nii']);
   f = 'i1-(flipud(i1))'; 
   flags = {[],[],[],[]}; 
   Q = spm_imcalc_ui(imCalcInput,imCalcOutputName,f,flags);
end;
